/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import util.Atribut;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author mira
 */
public class DBBroker {

    static Connection con;
    static Statement st;
    static DBBroker instance;

    public DBBroker() {

    }

    public static DBBroker getInstance() {
        if (instance == null) {

            instance = new DBBroker();
            instance.poveziSe();
        }

        return instance;

    }

    private void poveziSe() {
        try {
            String databaseIP = "localhost";
            String port = "3306";
            String driver = "com.mysql.jdbc.Driver";
            String userName = "root";
            String password = "root";
            String databaseName = "softverskiproces2019";
            instance = new DBBroker();
            String databaseURL = "jdbc:mysql://" + databaseIP + ":" + port + "/" + databaseName;
            con = DriverManager.getConnection(databaseURL, userName, password);

        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public List<Atribut> vratiMetaPodatkeTabele(String nazivTabele) throws SQLException {

        String upit = "Select * from " + nazivTabele;
        Statement st = con.createStatement();
        ResultSet rs = st.executeQuery(upit);

        ResultSetMetaData rsmd = rs.getMetaData();

        List<Atribut> listaAtributa = new ArrayList<>();

        for (int i = 1; i < rsmd.getColumnCount() + 1; i++) {
            Atribut atribut = new Atribut();
            atribut.setNaziv(rsmd.getColumnName(i));
            atribut.setTip(getJavaType(rsmd.getColumnType(i)));
            listaAtributa.add(atribut);
        }

        ResultSet foreignKeyRS = getForeignKeyInfo(nazivTabele);
        while (foreignKeyRS.next()) {

            String fkName = foreignKeyRS.getString("FKCOLUMN_NAME");
            for (int i = 0; i < listaAtributa.size(); i++) {
                
                Atribut att = listaAtributa.get(i);

                if (fkName.equals(att.getNaziv())) {
                    att.setForeignKey(true);
                    att.setForeignKeyTableName(foreignKeyRS.getString("PKTABLE_NAME"));
//                    jtblConstrainTable.setValueAt(new Boolean(true), i, 11);
//                    jtblConstrainTable.setValueAt(foreignKeyRS.getString("PKTABLE_NAME"), i, 12);
//                    jtblConstrainTable.setValueAt(foreignKeyRS.getString("PKCOLUMN_NAME"), i, 13);
                }

            }

        }

        return listaAtributa;

    }

    public ResultSet getForeignKeyInfo(String tableName) {

        try {
            DatabaseMetaData dbmd = con.getMetaData();
            ResultSet rs = dbmd.getImportedKeys("softverskiProces2019", "", tableName);
            //showQueryResults(rs);
            return rs;
            //rs = dbmd.getColumns("SkiBus", "dbo", tableName, "SifraKlijenta");
            //showQueryResults(rs);

        } catch (SQLException sQLException) {
            System.out.println("e" + sQLException);
            return null;
        }
    }
    
    public ArrayList getAllTablesFromDatabase() {
        ArrayList tableList=new ArrayList();
        try {
            DatabaseMetaData dbmd = con.getMetaData();
            ResultSet rs = dbmd.getTables("softverskiproces2019", "", null, new String[]{"TABLE"});            
            while(rs.next()){
                tableList.add(rs.getString("TABLE_NAME"));

            }
        } catch (SQLException sQLException) {
            System.out.println(""+sQLException);
        }
        return tableList;
    }

    public static String getJavaType(int colType) {

        switch (colType) {

            case Types.CHAR:
                return "String";
            case Types.VARCHAR:
                return "String";
            case Types.LONGNVARCHAR:
                return "String";
            case Types.NVARCHAR:
                return "String";
            case Types.LONGVARCHAR:
                return "String";
            case Types.SMALLINT:
                return "Boolean";
            case Types.NUMERIC:
                return "Double";
            case Types.DECIMAL:
                return "Double";
            case Types.DOUBLE:
                return "Double";
            case Types.INTEGER:
                return "Integer";
            case Types.BIGINT:
                return "Long";
            case Types.FLOAT:
                return "Float";
            case Types.REAL:
                return "Float";
            case Types.DATE:
                return "java.util.Date";
            case Types.TIME:
                return "java.sql.Time";
            case Types.TIMESTAMP:
                return "java.util.Date";
        }

        return "UnknownType";
    }
    
    
    public static void main(String[] args) throws SQLException {
        DBBroker dbbr = new DBBroker();
        dbbr.poveziSe();
        List<Atribut> list = dbbr.vratiMetaPodatkeTabele("korisnik");
        for (int i = 0; i < list.size(); i++) {
            Atribut att = list.get(i);
            System.out.println(att);
        }
        
    }

}
